require 'uri'
require 'net/http'
require "active_support/core_ext"

class EventNotification
  def self.build_hash(exception,request,params)
    hash={}
    hash[:event]={:klass => params[:controller], :method =>params[:action] , :message =>  exception.message,
                  :type => "Error"}

    hash[:message] = {:session =>  request.session.to_hash, :stack_trace => exception.backtrace,
                     :url => request.original_url, :ip_address => request.remote_ip, :time =>Time.now ,
                     :environment => Rails.env , :attrs => params}

    hash
  end
end

class EventNotifier



  # Configure through hash
  def configure(opts = {})
  	@config = {
              :api_key=> "",
              :uri =>""
            }

  @valid_config_keys = @config.keys

    opts.each {|k,v| @config[k.to_sym] = v if @valid_config_keys.include? k.to_sym}
  end

def self.default_ignore_exceptions
    [].tap do |exceptions|
      
      exceptions << 'ActionController::RoutingError'
		exceptions << 'ActionController::InvalidAuthenticityToken'
		exceptions << 'CGI::Session::CookieStore::TamperedWithCookie'
		exceptions << 'ActionController::UnknownAction'
		exceptions << 'ActionController::UnknownHttpMethod'
	exceptions << 'Mongoid::Errors::DocumentNotFound'
    end
 end

 def read_config
 	path_to_yaml_file = "#{Rails.root}/config/appmonitor.yml"
 	begin
      config = YAML::load(IO.read(path_to_yaml_file))
      Rails.logger.info(config)
    rescue Errno::ENOENT
return
    rescue Psych::SyntaxError
  return
    end
    configure(config)
 end

 def ignored_exception(ignore_array, exception)
    Array.wrap(ignore_array).map(&:to_s).include?(exception.class.name)
  end

 def initialize()
    read_config
    @config[:ignore_exceptions] ||= self.class.default_ignore_exceptions
  end

	def notify(exception, request,params)
		unless ignored_exception(@config[:ignore_exceptions],exception )

			event = EventNotification.build_hash(exception,request,params)
			@event = event.to_json
			uri = URI.parse(@config[:uri])
			token = @config[:api_key]

			https = Net::HTTP.new(uri.host, uri.port)
			https.use_ssl = false
			request = Net::HTTP::Post.new(uri.path,initheader = {"Content-Type" =>"application/json", "Authorization" => "Token token=#{token}"})

			request.body = "#@event"

			response = https.request(request)
		end
	end


  

end
